// new_ball.hh - how to create new balls
//
// Copyright (C) 2000 Trevor Spiteri
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef NEW_BALL_HH
#define NEW_BALL_HH

#include <string>
#include <vector>

#include "ball.hh"
#include "misc.hh"

namespace balls {
    
    class def_creator : public creator {
    public:
        def_creator(ball_info* inf, ship* s);
        void move(int t);
    private:
        ball_info* info;
        ship* sp;
        int time;
        int new_ball_calls;
        double av_vel;

        class period {
        public:
            void add(const std::string& n, int c);
            void remove(std::string& n);
            void prepare();
            const std::string& get(misc::random& r);
        private:
            typedef std::map<std::string, int> map;
            map m;
            std::vector<std::string> name;
            misc::rand_int ran;
        };

        std::vector<period> periods;
    };

} // namespace balls

#endif // !NEW_BALL_HH
